.\"	$OpenBSD: fread.3,v 1.6 2013/06/05 03:39:23 tedu Exp $
.\"
.\" Copyright (c) 1990, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" Chris Torek and the American National Standards Committee X3,
.\" on Information Processing Systems.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd $Mdocdate: June 5 2013 $
.Dt FREAD 3
.Os
.Sh NAME
.Nm fread ,
.Nm fwrite
.Nd binary stream input/output
.Sh SYNOPSIS
.In stdio.h
.Ft size_t
.Fn fread "void *ptr" "size_t size" "size_t nmemb" "FILE *stream"
.Ft size_t
.Fn fwrite "const void *ptr" "size_t size" "size_t nmemb" "FILE *stream"
.Sh DESCRIPTION
The function
.Fn fread
reads
.Fa nmemb
objects, each
.Fa size
bytes long, from the stream pointed to by
.Fa stream ,
storing them at the location given by
.Fa ptr .
.Pp
The function
.Fn fwrite
writes
.Fa nmemb
objects, each
.Fa size
bytes long, to the stream pointed to by
.Fa stream ,
obtaining them from the location given by
.Fa ptr .
.Sh RETURN VALUES
The functions
.Fn fread
and
.Fn fwrite
advance the file position indicator for the stream
by the number of bytes read or written.
They return the number of objects read or written.
If
.Fa size
or
.Fa nmemb
is 0,
.Fn fread
and
.Fn fwrite
return 0 with no change made to the
.Fa stream .
If an error occurs, or the end-of-file is reached,
the return value is a short object count (or zero).
.Pp
The function
.Fn fread
does not distinguish between end-of-file and error, and callers
must use
.Xr feof 3
and
.Xr ferror 3
to determine which occurred.
The function
.Fn fwrite
returns a value less than
.Fa nmemb
only if a write error has occurred.
.Sh SEE ALSO
.Xr read 2 ,
.Xr write 2
.Sh STANDARDS
The functions
.Fn fread
and
.Fn fwrite
conform to
.St -ansiC .
